#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>

using namespace std;

int binpow (int a, int n) {
	int res = 1;
	while (n)
		if (n & 1) {
			res *= a;
			--n;
		}
		else {
			a *= a;
			n >>= 1;
		}
	return res;
}

int comb(int K, int N, vector<int> &b, int number) // K - number of digits in pseudo-password, N - length of interval where we work
{
    std::string bitmask(K, 1); // K leading 1's
    bitmask.resize(N - 1, 0); // N - K trailing 0's
    do {
        vector<int> v = b;
        int num = 1;
        vector<int> divisors; // potential digits of the password
        for (int i = 0; i < N; ++i)
            if (bitmask[i] == 1)
            {
                divisors.push_back(v[i]);
                num *= v[i];
            }
        if (number % num != 0)
            continue;
        vector<int> bdiv = divisors;
        divisors.resize(4, 0);
        bdiv.resize(4, 1);

        do{

                int y = 1000 * divisors[0] + 100 * divisors[1] + 10 * divisors[2] + divisors[3];
                if (y * num == number)
                    return y;
        }while (prev_permutation(divisors.begin(), divisors.end()));
        do{

                int y = 1000 * bdiv[0] + 100 * bdiv[1] + 10 * bdiv[2] + bdiv[3];
                if (y * num == number)
                    return y;
        }while (prev_permutation(bdiv.begin(), bdiv.end()));
    }while (std::prev_permutation(bitmask.begin(), bitmask.end()));
    return -1;
}

int main()
{
    int n;
    cin >> n;
    vector<int> r;
    for (int i = 1; i <= n; i ++)
        if (n % i == 0)
        {
            r.push_back(i);
        }
    int y = 0;
    while (r[y] < 10)
        y ++;
    int ans = -11;
    for (int i = 1; i <= min(4, y + 1); i ++) // number of non-zero digits in password
        ans = max(ans, comb(i, y + 1, r, n));
    if (ans > 0)
        cout << ans;
    else
        cout << "ERROR";
    return 0;
}
