#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <math.h>

#define ll long long
#define ull unsigned long long

using namespace std;

const int inf = 1000000000;
const double eps = 1e-7;

void solve() {
	int n;
	cin >> n;
	vector<set<int>> g(n);
	for (int i = 0; i < n - 1; ++i) {
		int a, b;
		cin >> a >> b;
		g[a - 1].insert(b - 1);
		g[b - 1].insert(a - 1);
	}
	
	vector<pair<ll, int>> vert(n);
	for (int i = 0; i < n; ++i)
		vert[i] = {(int)g[i].size(), i};
	sort(vert.rbegin(), vert.rend());
	
	ll ans = 0;
	for (int i = 0; i < n; ++i)
		ans += vert[i].first * (vert[i].first - 1) / 2;
	
	ll add = 0;
	int ansa = -1, ansb = -1;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j)
			if (!g[vert[i].second].count(vert[j].second)) {
				int addi = (vert[i].first + 1) * (vert[i].first) / 2 - (vert[i].first) * (vert[i].first - 1) / 2;
				int addj = (vert[j].first + 1) * (vert[j].first) / 2 - (vert[j].first) * (vert[j].first - 1) / 2;
				
				if (add < addi + addj) {
					add = addi + addj;
					ansa = vert[i].second;
					ansb = vert[j].second;
				}
				
				break;
			}
	}
	
	cout << ans + add << endl;
	if (ansa > ansb)
		swap(ansa, ansb);
	cout << ansa + 1 << " " << ansb + 1 << endl;
}

int main() {
	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; ++i)
		solve();
	return 0;
}