#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <math.h>

#define ll long long
#define ull unsigned long long

using namespace std;

const int inf = 1000000000;
const double eps = 1e-7;

int n, m, d;
vector<int> col;
vector<vector<int>> empire;
vector<vector<int>> g;
vector<int> in_col;
vector<char> used;

void dfs(int v, int c1, int c2, int banid, int empid) {
	used[v] = 1;
	in_col[v] = c2;
	for (int to : g[v])
		if (col[to] != banid && !used[to]) {
			if ((col[to] != empid) || (col[to] == empid && (in_col[to] == c1 || in_col[to] == 0)))
				dfs(to, c1, c2, banid, empid);
		}
}

void solve() {
	cin >> n >> m >> d;
	col.resize(n);
	empire.resize(d);
	for (int i = 0; i < n; ++i) {
		cin >> col[i];
		--col[i];
		empire[col[i]].push_back(i);
	}
	
	g.resize(n);
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		g[a - 1].push_back(b - 1);
		g[b - 1].push_back(a - 1);
	}
	
	for (int empid = 0; empid < d; ++empid) {
		in_col.assign(n, 0);
		int c = 1;
		
		for (int banid = 0; banid < d; ++banid) {
			if (empid == banid)
				continue;
			/*
			cout << "empid = " << empid << endl;
			cout << "banid = " << banid << endl;
			*/
			used.assign(n, 0);
			for (int v : empire[empid])
				if (!used[v]) {
					/*
					cout << "dfs " << v << " " << in_col[v] << " " << c << " " << banid << endl;
					*/
					dfs(v, in_col[v], c, banid, empid);
					++c;
					/*
					for (int color : in_col)
						cout << color << " ";
					cout << endl;
					*/
				}
		}
		
		set<int> in_cols;
		vector<int> ans;
		for (int v : empire[empid])
			if (in_col[v] != 0 && !in_cols.count(in_col[v])) {
				in_cols.insert(in_col[v]);
				ans.push_back(v);
			}
		
		cout << ans.size();
		for (int v : ans)
			cout << " " << v + 1;
		cout << "\n";
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(NULL);
	
	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; ++i)
		solve();
	return 0;
}