#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <math.h>

#define ll long long
#define ull unsigned long long

using namespace std;

const int inf = 1000000000;
const double eps = 1e-7;

int mod = 3;

struct matrix {
	int n, m;
	vector<vector<long long>> a;
	matrix() {
		n = 0;
		m = 0;
	}
	matrix(vector<vector<long long>> &a) {
		this->a = a;
		n = a.size();
		m = (n ? a[0].size() : 0);
	}
	matrix operator*(const long long &k) {
		vector<vector<long long>> res = a;
		for (auto &row : res)
			for (auto &e : row)
				e = (e * k) % mod;
	}
	matrix operator*(const matrix &b) {
		vector<vector<long long>> res(n, vector<long long>(b.m));
		for (int i = 0; i < n; ++i)
			for (int j = 0; j < b.m; ++j)
				for (int k = 0; k < m; ++k)
					res[i][j] = (res[i][j] + a[i][k] * b.a[k][j]) % mod;
		return res;
	}
};

matrix binpow(matrix &a, long long p) {
	if (!p) {
		matrix res(vector<vector<long long>>(a.n, vector<long long>(a.n)));
		for (int i = 0; i < res.n; ++i)
			res.a[i][i] = 1;
		return res;
	}
	if (p & 1)
		return binpow(a, p - 1) * a;
	else {
		matrix res = binpow(a, p / 2);
		return res * res;
	}
}

void solve() {
	long long n;
	cin >> n;
	
	if (n == 0) {
		cout << 0 << endl;
		return;
	}
	
	matrix res(vector<vector<long long>>(2, vector<long long>(2, 1)));
	res.a[0][0] = 0;
	res = binpow(res, n - 1);
	matrix f(vector<vector<long long>>(2, vector<long long>(1)));
	f.a[1][0] = 1;
	cout << (res * f).a[1][0] << endl;
}

int main() {
	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; ++i)
		solve();
	return 0;
}