#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <math.h>

#define ll long long
#define ull unsigned long long

using namespace std;

const int inf = 1000000000;
const double eps = 1e-7;

typedef struct FibMatrix{
	long long ul, ur, dl, dr;
} FibMatrix;

FibMatrix *mulMatrix2(FibMatrix *a, FibMatrix *b) {
	FibMatrix *res = new FibMatrix;
	res->ul = (a->ul * b->ul + a->ur * b->dl) % 3;
	res->ur = (a->ul * b->ur + a->ur * b->dr) % 3;
	res->dl = (a->dl * b->ul + a->dr * b->dl) % 3;
	res->dr = (a->dl * b->ur + a->dr * b->dr) % 3;
	return res;
}

FibMatrix *binpowMatrix2(FibMatrix *fm, int n) {
	FibMatrix *res = new FibMatrix;
	res->ul = 1;
	res->ur = 0;
	res->dl = 0;
	res->dr = 1;
	while (n) {
		if (n & 1)
			res = mulMatrix2(res, fm);
		fm = mulMatrix2(fm, fm);
		n >>= 1;
	}
	return res;
}

void solve() {
	FibMatrix *fm = new FibMatrix;
	fm->ul = 0;
	fm->ur = 1;
	fm->dl = 1;
	fm->dr = 1;
	long long n;
	scanf("%I64d", &n);
	if (n == 0)
		printf("%d\n", 0);
	else if (n == 1)
		printf("%d\n", 1);
	else {
		fm = binpowMatrix2(fm, n - 1);
		printf("%lld\n", fm->dr);
	}
}

int main() {
	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; ++i)
		solve();
	return 0;
}