#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <math.h>

#define ll long long
#define ull unsigned long long

using namespace std;

const int inf = 1000000000;
const double eps = 1e-7;

vector<int> pfunc(const vector<int> &s) {
	vector<int> p(s.size());
	for (int i = 1; i < s.size(); ++i) {
		int j = p[i - 1];
		for (; j > 0 && s[i] != s[j]; j = p[j - 1]);
		p[i] = j + (s[i] == s[j]);
	}
	return p;
}

void solve() {
	int n;
	cin >> n;
	vector<vector<int>> a(n, vector<int>(n));
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < n; ++j)
			cin >> a[i][j];
	vector<vector<int>> b(n, vector<int>(n));
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < n; ++j)
			cin >> b[i][j];
	
	bool ans = true;
	for (int t = 0; t < n / 2; ++t) {
		//int x = t; y = t;
		vector<int> pat;
		vector<int> str;
		for (int j = t; j < n - t; ++j) {
			pat.push_back(a[t][j]);
			str.push_back(b[t][j]);
		}
		for (int i = t + 1; i < n - t; ++i) {
			pat.push_back(a[i][n - 1 - t]);
			str.push_back(b[i][n - 1 - t]);
		}
		for (int j = n - 1 - t - 1; j >= t; --j) {
			pat.push_back(a[n - 1 - t][j]);
			str.push_back(b[n - 1 - t][j]);
		}
		for (int i = n - 1 - t - 1; i >= t + 1; --i) {
			pat.push_back(a[i][t]);
			str.push_back(b[i][t]);
		}
		
		int sz = str.size();
		
		vector<int> s;
		for (int i = 0; i < sz; ++i)
			s.push_back(pat[i]);
		s.push_back(0);
		for (int i = 0; i < sz; ++i)
			s.push_back(str[i]);
		for (int i = 0; i < sz; ++i)
			s.push_back(str[i]);
		
		vector<int> pf = pfunc(s);
		
		bool res = false;
		for (int i = 0; i < pf.size(); ++i)
			res |= (pf[i] == sz);
		
		ans &= res;
	}
	
	cout << (ans ? "YES" : "NO") << endl;
}

int main() {
	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; ++i)
		solve();
	return 0;
}