#include <bits/stdc++.h>

using namespace std;

const int MAXN = 200000; //построить один раз на все тесты
int rnd[MAXN];
int tree_size = 0;

typedef long long ll;

int nextrnd() {
	if (tree_size == 0) { //делаем список попарно различных случайных чисел, которые будут приоритетами
		for (int i = 0; i < MAXN; i++)
			rnd[i] = i;

		srand(time(0) + 284839); //куда рандомнее-то

		for (int i = MAXN-1; i >= 0; i--) {
			int j = rand() % MAXN;
			swap(rnd[i], rnd[j]);
		}
	}

	return rnd[tree_size++];
}

struct Node { //узел дерева по неявному ключу
	int k; //значение
	int y; //приоритет
	int n; //количество элементов в поддереве
	int max; //максимальный элемент в поддереве
	Node *left, *right;
};

int get_max(Node *v) {
	if (v == nullptr) return 0;
	return v->max;
}

int get_n(Node *v) {
	if (v == nullptr) return 0;
	return v->n;
}

void update(Node *v) {
	if (v != nullptr) {
		v->n = 1 + get_n(v->left) + get_n(v->right);
		v->max = max(max(v->k, get_max(v->left)), get_max(v->right));
	}
}


pair<Node*, Node*> split(Node *v, int x) { //отрезает поддерево из x самых левых вершин дерева
	if (v == nullptr) return {nullptr, nullptr};

	int n = get_n(v->left); //неявный ключ вершины
	if (n < x) {
		auto [v1, v2] = split(v->right, x - (n + 1));
		v->right = v1;

		update(v);
		return {v, v2};
	}
	else {
		auto [v1, v2] = split(v->left, x);
		v->left = v2;

		update(v);
		return {v1, v};
	}
}

int find_max_pos(Node *v) {
	if (v == nullptr)
		return 0; //вообще не должно вызваться

	int n = get_n(v->left);

	if (v->k > get_max(v->left) && v->k >= get_max(v->right)) //в вершине левый максимум
		return n;
	if (get_max(v->left) >= get_max(v->right)) //>=, ищем левый
		return find_max_pos(v->left);
	else
		return find_max_pos(v->right) + (n + 1);
}

Node* merge(Node *v1, Node *v2) {
	if (v1 == nullptr) return v2;
	if (v2 == nullptr) return v1;

	if (v1->y > v2->y) { //v1 -- новый корень
		v1->right = merge(v1->right, v2);

		update(v1);
		return v1;
	}
	else { //v2
		v2->left = merge(v1, v2->left);

		update(v2);
		return v2;
	}
}

Node* insert(Node *v, int k) {
	auto xv = new Node{k, nextrnd(), 1, k, nullptr, nullptr};

	return merge(v, xv); //поскольку добавляем по возрастанию неявного ключа при построении и больше не вызываем
}


int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;

	Node *root = nullptr;
	for (int i = 0; i < n; i++) {
		int a;
		cin >> a;
		root = insert(root, a);
	}

	ll cnt = 0;

	for (int i = 0; i < n; i++) {//n раз отрежем максимум
		int x = find_max_pos(root);

		if (x != -1) {
			auto [v1, v2] = split(root, x);

			if (v1 != nullptr) {
				cnt += v1->n; //столько карт перекладываем
			}
			auto[v3, v4] = split(v2, 1); //v3 состоит из 1 элемента - максимума
			delete v3; //delete v3; тоже норм

			root = merge(v4, v1);
		}
	}

	cout << cnt;
}
