import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.Comparator;
import java.util.HashSet;
import java.util.StringTokenizer;

public class Quarter_Champ_C_HighwayNetwork {
    public static void main(String[] args) throws Exception{
        FastIn in = new FastIn();
        int n = in.nextInt();
        int[][] ways = new int[(n-1)*2][2];//список смежности
        for (int i = 0; i < n-1; i++) {
            int from = in.nextInt()-1, to = in.nextInt()-1;
            ways[i][0] = from;
            ways[i][1] = to;
            ways[i+n-1][1] = from;
            ways[i+n-1][0] = to;
        }
        Arrays.sort(ways, Comparator.comparingInt((int[] arr)->arr[0]).thenComparingInt((int[] arr)->arr[1]));

        /*System.out.println();
        for (int i = 0; i < ways.length; i++) {
            System.out.println(ways[i][0] + " " + ways[i][1]);
        }
        System.out.println();*/

        int[] vs = new int[n]; //starts in
        for (int i = 0, curr = -1; i < ways.length; i++) {
            if (ways[i][0]>curr) vs[++curr]=i;
        }

        /*System.out.println();
        for (int i = 0; i < vs.length; i++) {
            System.out.print(vs[i]+" ");
        }
        System.out.println();*/

        int[] cnts = new int[vs.length];

        long tunnels = 0;
        for (int i = 0; i < vs.length; i++) {
            long cnt = getWaysCnt(i, vs, ways.length);
            cnts[i] = (int)cnt;
            //System.out.println("cnt: "+cnt);
            long t = cnt*(cnt-1)/2; //сумма арифмеитической прогрессии
            //System.err.println("tunnels: "+t);
            tunnels += t;
        }

        int max = 0;
        int maxId = -1;
        for (int i = 0; i < vs.length; i++) {
            int cnt = cnts[i];
            if (maxId==-1 || cnt>max){
                maxId = i;
                max = cnt;
            }
        }

        boolean[] near = new boolean[vs.length];
        near[maxId] = true;
        int max2Near = 0;
        int max2IdNear = -1;
        for (int i = vs[maxId], end = ((maxId+1)==vs.length?ways.length:vs[maxId+1]); i < end; i++) {
            int nextV = ways[i][1];
            near[nextV] = true;
            int cnt = cnts[nextV];
            //System.err.println("near: "+nextV+"cnt: "+cnt);
            if (max2IdNear==-1 || cnt>max2Near){
                max2IdNear = nextV;
                max2Near = cnt;
            }
        }

        int max2 = 0;
        int max2Id = -1;
        for (int i = 0; i < vs.length; i++) {
            if (near[i]==true) continue;
            int cnt = cnts[i];
            if (max2Id==-1 || cnt>max2){
                max2Id = i;
                max2 = cnt;
            }
        }

        int addTunnelsNear = max+max2Near-2;

        int addTunnels = 0;
        if (max2Id!=-1) addTunnels = max+max2;
        else {
            int max3 = 0;
            int max3Id = -1;
            for (int i = 0; i < vs.length; i++) {
                if (near[i]==true && i!=maxId && i!=max2IdNear){
                    int cnt = cnts[i];
                    if (max3Id==-1 || cnt>max3){
                        max3Id = i;
                        max3 = cnt;
                    }
                }
            }
            addTunnels = max2Near+max3;
            maxId = max3Id;
        }

        if (true){
            System.out.println(
                    (tunnels+addTunnels) + "\n" +
                            (max2Id+1) + " " + (maxId+1)
            );
        } else {
            System.out.println(
                    (tunnels+addTunnelsNear) + "\n" +
                            (max2IdNear+1) + " " + (maxId+1)
            );
        }
        //System.err.println("tunnels: " + tunnels);
        //System.err.println(maxId+" "+max2Id+" "+max2IdNear);
        //System.err.println(max+" "+max2+" "+max2Near);

    }

    private static int getWaysCnt(int vId, int[] vs, int waysLen){
        int curr = vs[vId];
        int next = (vId+1)==vs.length ? waysLen : vs[vId+1];
        int cnt = next-curr;
        return cnt;
    }

    private static final class FastIn{
        public final BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        public StringTokenizer st = null;

        public String nextWord() throws Exception {
            if (st==null || !st.hasMoreTokens()) st = new StringTokenizer(br.readLine(), " ");
            return st.nextToken();
        }

        public int nextInt() throws Exception { return Integer.parseInt(nextWord()); }

        public int[] intArr(int len) throws Exception {
            int[] arr = new int[len];
            for (int i = 0; i < len; i++) arr[i] = nextInt();
            return arr;
        }
    }
}
